# Solana Farms

## Introduction

Solana Farms is a collection of easy-to-use tools and blockchain contracts for yield optimization strategies.

It is powered by the Solana blockchain to allow for frequent automatic compounding, staking, and rebalancing.

One of the distinct features of this platform is the on-chain Reference Database. Metadata for all objects: Tokens, Pools, Farms, Vaults, Funds, etc., is stored in the blockchain, so clients don't need any state or hard-coded data.

Solana Farms provides a unified interface to Funds, Vaults, regular AMM Pools, Farms, and basic operations on tokens and accounts. Raydium, Saber, and Orca protocols are currently supported, but others are under development.

This source code is an example that third parties can utilize to create and use their own version of a yield farming or aggregation service.

## Quick start

To quickly build, test and deploy Solana Farms and try it out in action, please follow the [Quick Start](https://github.com/solana-labs/solana-program-library/blob/master/farms/docs/quick_start.md) guide.

## Dive in

If you want to learn more about the tools and building blocks of the Solana Farms suite, follow the links below:

[Rust Client](https://github.com/solana-labs/solana-program-library/blob/master/farms/docs/rust_client.md)

[Http Client](https://github.com/solana-labs/solana-program-library/blob/master/farms/docs/http_client.md)

[Farm Client CLI](https://github.com/solana-labs/solana-program-library/blob/master/farms/docs/farm_client_cli.md)

[Farm Control CLI](https://github.com/solana-labs/solana-program-library/blob/master/farms/docs/farm_ctrl_cli.md)

[Farm SDK](https://github.com/solana-labs/solana-program-library/blob/master/farms/docs/sdk.md)

[Routers](https://github.com/solana-labs/solana-program-library/blob/master/farms/docs/routers.md)

[Vaults](https://github.com/solana-labs/solana-program-library/blob/master/farms/docs/vaults.md)

[Fund](https://github.com/solana-labs/solana-program-library/blob/master/farms/docs/fund.md)

[Multisig](https://github.com/solana-labs/solana-program-library/blob/master/farms/docs/multisig.md)

[Governance](https://github.com/solana-labs/solana-program-library/blob/master/farms/docs/governance.md)

## Support

For details on how to get help or report a problem, see the [Support](https://github.com/solana-labs/solana-program-library/blob/master/farms/docs/support.md) page.

## Contributing

Contributions are very welcome. Please refer to the [Contributing](https://github.com/solana-labs/solana/blob/master/CONTRIBUTING.md) guidelines for more information.

## License

Solana Farms is a part of the Solana Program Library, which is released under this [License](https://github.com/solana-labs/solana-program-library/blob/master/LICENSE).

## Disclaimer

By accessing or using Solana Farms or any of its components, you accept and agree with the [Disclaimer](https://github.com/solana-labs/solana-program-library/blob/master/farms/docs/disclaimer.md).
