/**
 * This code was GENERATED using the solita package.
 * Please DO NOT EDIT THIS FILE, instead rerun solita to update it or write a wrapper to add functionality.
 *
 * See: https://github.com/metaplex-foundation/solita
 */

import * as splToken from '@solana/spl-token'
import * as beet from '@metaplex-foundation/beet'
import * as web3 from '@solana/web3.js'

/**
 * @category Instructions
 * @category InitializeMint
 * @category generated
 */
export type InitializeMintInstructionArgs = {
  instructionArgs: number
}
/**
 * @category Instructions
 * @category InitializeMint
 * @category generated
 */
export const InitializeMintStruct = new beet.BeetArgsStruct<
  InitializeMintInstructionArgs & {
    instructionDiscriminator: number
  }
>(
  [
    ['instructionDiscriminator', beet.u8],
    ['instructionArgs', beet.u8],
  ],
  'InitializeMintInstructionArgs'
)
/**
 * Accounts required by the _InitializeMint_ instruction
 *
 * @property [_writable_, **signer**] mint
 * @property [_writable_, **signer**] payer
 * @property [] upstreamAuthority
 * @category Instructions
 * @category InitializeMint
 * @category generated
 */
export type InitializeMintInstructionAccounts = {
  mint: web3.PublicKey
  payer: web3.PublicKey
  upstreamAuthority: web3.PublicKey
  systemProgram?: web3.PublicKey
  tokenProgram?: web3.PublicKey
}

export const initializeMintInstructionDiscriminator = 0

/**
 * Creates a _InitializeMint_ instruction.
 *
 * @param accounts that will be accessed while the instruction is processed
 * @param args to provide as instruction data to the program
 *
 * @category Instructions
 * @category InitializeMint
 * @category generated
 */
export function createInitializeMintInstruction(
  accounts: InitializeMintInstructionAccounts,
  args: InitializeMintInstructionArgs,
  programId = new web3.PublicKey('mTok58Lg4YfcmwqyrDHpf7ogp599WRhzb6PxjaBqAxS')
) {
  const [data] = InitializeMintStruct.serialize({
    instructionDiscriminator: initializeMintInstructionDiscriminator,
    ...args,
  })
  const keys: web3.AccountMeta[] = [
    {
      pubkey: accounts.mint,
      isWritable: true,
      isSigner: true,
    },
    {
      pubkey: accounts.payer,
      isWritable: true,
      isSigner: true,
    },
    {
      pubkey: accounts.upstreamAuthority,
      isWritable: false,
      isSigner: false,
    },
    {
      pubkey: accounts.systemProgram ?? web3.SystemProgram.programId,
      isWritable: false,
      isSigner: false,
    },
    {
      pubkey: accounts.tokenProgram ?? splToken.TOKEN_PROGRAM_ID,
      isWritable: false,
      isSigner: false,
    },
  ]

  const ix = new web3.TransactionInstruction({
    programId,
    keys,
    data,
  })
  return ix
}
