/**
 * This code was GENERATED using the solita package.
 * Please DO NOT EDIT THIS FILE, instead rerun solita to update it or write a wrapper to add functionality.
 *
 * See: https://github.com/metaplex-foundation/solita
 */

import * as splToken from '@solana/spl-token'
import * as beet from '@metaplex-foundation/beet'
import * as web3 from '@solana/web3.js'

/**
 * @category Instructions
 * @category MintTo
 * @category generated
 */
export type MintToInstructionArgs = {
  instructionArgs: beet.bignum
}
/**
 * @category Instructions
 * @category MintTo
 * @category generated
 */
export const MintToStruct = new beet.BeetArgsStruct<
  MintToInstructionArgs & {
    instructionDiscriminator: number
  }
>(
  [
    ['instructionDiscriminator', beet.u8],
    ['instructionArgs', beet.u64],
  ],
  'MintToInstructionArgs'
)
/**
 * Accounts required by the _MintTo_ instruction
 *
 * @property [_writable_] mint
 * @property [_writable_] account
 * @property [**signer**] upstreamAuthority
 * @property [] freezeAuthority
 * @category Instructions
 * @category MintTo
 * @category generated
 */
export type MintToInstructionAccounts = {
  mint: web3.PublicKey
  account: web3.PublicKey
  upstreamAuthority: web3.PublicKey
  freezeAuthority: web3.PublicKey
  tokenProgram?: web3.PublicKey
}

export const mintToInstructionDiscriminator = 3

/**
 * Creates a _MintTo_ instruction.
 *
 * @param accounts that will be accessed while the instruction is processed
 * @param args to provide as instruction data to the program
 *
 * @category Instructions
 * @category MintTo
 * @category generated
 */
export function createMintToInstruction(
  accounts: MintToInstructionAccounts,
  args: MintToInstructionArgs,
  programId = new web3.PublicKey('mTok58Lg4YfcmwqyrDHpf7ogp599WRhzb6PxjaBqAxS')
) {
  const [data] = MintToStruct.serialize({
    instructionDiscriminator: mintToInstructionDiscriminator,
    ...args,
  })
  const keys: web3.AccountMeta[] = [
    {
      pubkey: accounts.mint,
      isWritable: true,
      isSigner: false,
    },
    {
      pubkey: accounts.account,
      isWritable: true,
      isSigner: false,
    },
    {
      pubkey: accounts.upstreamAuthority,
      isWritable: false,
      isSigner: true,
    },
    {
      pubkey: accounts.freezeAuthority,
      isWritable: false,
      isSigner: false,
    },
    {
      pubkey: accounts.tokenProgram ?? splToken.TOKEN_PROGRAM_ID,
      isWritable: false,
      isSigner: false,
    },
  ]

  const ix = new web3.TransactionInstruction({
    programId,
    keys,
    data,
  })
  return ix
}
